#include <stm32f10x_lib.h>



#define AdresseExpanseur1 0x40	/*Adresse du premier expanseur de port I2C, de type  PCF8574 */
#define AdresseExpanseur2 0x42	/*Adresse du deuxime expanseur de port I2C, de type  PCF8574 */

#define AdresseCommande 0x4A	/*Adresse de commande du circuit intgr MCP23017, reli aux broches  R/S ,  R/W ,  E, et  DB0    DB7  de l'afficheur alphanumrique*/

#define AdresseCapteur 0x94	/*Adresse de commande du capteur de temprature TMP100*/



void Delai(int t);
void Initialisation_I2C_1(void);
int LirePlusieursOctets(unsigned char adresse, unsigned char nombre, unsigned char receptacle[]);
int Lire16Nouvelle(unsigned char adresse, unsigned char Commande, unsigned char adresseDeLecture, unsigned char * Donnee1, unsigned char * Donnee2);
int EcrirePlusieursOctets(unsigned char adresse, unsigned char nombre, unsigned char donnees[]);
int Ecrire(unsigned char adresse, unsigned char donnee);
int Ecrire16Court(unsigned char adresse, unsigned char commande, unsigned char donnee);
int Ecrire16Nouvelle(unsigned char adresse, unsigned char commande, unsigned char donnee1, unsigned char donnee2);
unsigned char Retourner(unsigned char paquet);
void EnvoiCommande(unsigned char commande);
void PlacerCurseur(unsigned char adresse_du_curseur);void EnvoiDonnee(unsigned char donnee);
void InitialisationAfficheur(void);
void MiseVeilleAfficheur(void);unsigned char ObtenirAdresseActuelle(void);void AfficheCaractere(unsigned char c);
void AfficheTexte(unsigned char * texte);
void CommandeSpeciale(unsigned char uoct_special);
void ChargeCaracteres(unsigned char str_nouveaucaractere[]);
void ConvertirEtAfficher(int valeur, unsigned char base);
int Configuration_pour_capteur(unsigned char a); 



unsigned char speciaux[56] = {0x0C, 0x12, 0x12, 0x0C, 0x00, 0x00, 0x00, 0x00,	/*Symbole   */
							  0x00, 0x1F, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
							  0x00, 0x00, 0x1F, 0x00, 0x00, 0x00, 0x00, 0x00,
							  0x00, 0x00, 0x00, 0x1F, 0x00, 0x00, 0x00, 0x00,
							  0x00, 0x00, 0x00, 0x00, 0x1F, 0x00, 0x00, 0x00,
							  0x00, 0x00, 0x00, 0x00, 0x00, 0x1F, 0x00, 0x00,
							  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x1F, 0x00};

unsigned char AdresseCurseurActuelle;

unsigned char EtatDesLED;



/*Fonction qui sert  faire perdre son temps au STM32F100RB

Paramtre d'entre :

t - Valeur qui est proportionnelle au dlai que l'on souhaite obtenir.

Valeur de retour :

Aucune.

*/
void Delai(int t)
	{
		int i;
		for(i = 0; i < (10 * t); i++);
	}



/*Initialisation du module  I2C 1  du STM32F100RB en tant que  Matre 

Paramtre d'entre :

Aucun.

Valeur de retour :

Aucune.

*/
void Initialisation_I2C_1(void)
	{
		/* GPIOB clock enable */
		RCC->APB2ENR |= (1 << 3);

        /* I2C1 clock enable */
		RCC->APB1ENR |= (1 << 21);

        /* I2C1 SDA and SCL configuration */
		GPIOB->CRL = ((GPIOB->CRL & 0x00FFFFFF) | (0xFF000000));

        /* Enable I2C1 reset state */
		RCC->APB1RSTR |= (1 << 21);
        /* Release I2C1 from reset state */
		RCC->APB1RSTR &= ~(1 << 21);

		I2C1->CR1 = 0x0401;
		I2C1->CR2 = 0x0108;
		
		I2C1->SR1 = 0x0000;
		I2C1->SR2 = 0x0000;
		
		I2C1->CCR = 0x8006;
		
		I2C1->OAR1 = 0x4028;
		I2C1->OAR2 = 0x0000;
		
		I2C1->TRISE = 0x0003;
	}



/*Lecture d'un ou de plusieurs octets grce au module  I2C 1  du STM32F100RB

Paramtres d'entre :

adresse - Adresse de lecture, sur le bus  I2C 1  du composant que l'on souhaite lire,
nombre - Nombre d'octets  lire,
receptacle[] - Tableau qui est destin  contenir le ou les octets qui auront t lus.

Valeur de retour :

1 si la lecture s'est effectue correctement, -1 s'il y a eu une erreur lors de la lecture.

*/
int LirePlusieursOctets(unsigned char adresse, unsigned char nombre, unsigned char receptacle[])
	{
	    int temp = 0;
	    int Timeout = 0;
			if(nombre <= 2)
		  		{
		           /* Set POS bit */
		            I2C1->CR1 |= 0x0800;
		            Timeout = 0xFFFF;
		            /* Send START condition */
		            I2C1->CR1 |= 0x0100;
		            /* Wait until SB flag is set: EV5 */
			            while ((I2C1->SR1&0x0001) != 0x0001)
				            {
				                if (Timeout-- == 0)
				                    return (-1);
				            }
		            Timeout = 0xFFFF;
		            /* Send the slave address */
		            I2C1->DR = adresse;
		            /* Wait until ADDR is set: EV6 */
			            while((I2C1->SR1&0x0002) != 0x0002)
				            {
				                if(Timeout-- == 0)
				                    return (-1);
				            }
		            /* Clear ADDR by reading SR2 register  */
		            temp = I2C1->SR2;
		            /* Clear ACK */
		            I2C1->CR1 &= 0xFBFF;
		            /* Wait until BTF is set */
		            	while((I2C1->SR1 & 0x00004) != 0x000004);
		            /* Program the STOP */
		            I2C1->CR1 |= 0x0200;
		            /* Read first data */
		            receptacle[0] = I2C1->DR;
						if(nombre == 2)
							{
					            /* Read second data */
					            receptacle[1] = I2C1->DR;
							}
			            /* Make sure that the STOP bit is cleared by Hardware before CR1 write access */
			            while ((I2C1->CR1&0x200) == 0x200);
		            /* Enable Acknowledgement to be ready for another reception */
		            I2C1->CR1  |= 0x0400;
		            /* Clear POS bit */
		            I2C1->CR1  &= 0xF7FF;
				}
			return 1;
	}



/*Lecture de deux octets grce au module  I2C 1  du STM32F100RB

Paramtres d'entre :

adresse - Adresse d'criture, sur le bus  I2C 1 , du composant que l'on souhaite lire,
Commande - Numro du registre que l'on souhaite lire,
adresseDeLecture - Adresse de lecture, sur le bus  I2C 1  du composant que l'on souhaite lire,
* Donne 1 - Pointeur sur une variable, de type  unsigned char , destine  contenir la valeur du premier octet  lire,
* Donne 2 - Pointeur sur une variable, de type  unsigned char , destine  contenir la valeur du deuxime octet  lire.

Valeur de retour :

1 si la lecture s'est effectue correctement, -1 s'il y a eu une erreur lors de la lecture.

*/
int Lire16Nouvelle(unsigned char adresse, unsigned char Commande, unsigned char adresseDeLecture, unsigned char * Donnee1, unsigned char * Donnee2)
	{
		unsigned char tampon[2];
			if(Ecrire(adresse, Commande) == (-1))	/*On indique, dans un premier temps, le numro du registre dont on souhaite lire le contennu*/
				{
				 	return (-1);
				}
			if(LirePlusieursOctets(adresseDeLecture, 2, tampon) == (-1))	/*On lit, dans un second temps, les deux octets du registre slectionn*/
				{
				 	return (-1);
				}
			*Donnee1 = tampon[0];
			*Donnee2 = tampon[1];
		return 1;
	}



/*Ecriture d'un ou de plusieurs octets grce au module  I2C 1  du STM32F100RB

Paramtres d'entre :

adresse - Adresse d'criture, sur le bus  I2C 1 , du composant que l'on souhaite crire,
nombre - Nombre d'octets  crire,
donnees[] - Tableau qui contient le ou les octets  crire.

Valeur de retour :

1 si l'criture s'est effectue correctement, -1 s'il y a eu une erreur lors de l'criture.

*/
int EcrirePlusieursOctets(unsigned char adresse, unsigned char nombre, unsigned char donnees[]) 
	{
		int temp = 0;
	    int Timeout = 0;
		int p = 0;
        Timeout = 0xFFFF;
        /* Send START condition */
        I2C1->CR1 |= 0x0100;
	        /* Wait until SB flag is set: EV5 */
	        while ((I2C1->SR1&0x0001) != 0x0001)
		        {
		            if (Timeout-- == 0)
						{
		 					Initialisation_I2C_1();
			                	return (-1);
						}
		        }
        /* Send the slave address */
        I2C1->DR = adresse;
        Timeout = 0xFFFF;
	        /* Wait until ADDR is set: EV6 */
	        while ((I2C1->SR1 &0x0002) != 0x0002)
		        {
		            if (Timeout-- == 0)
						{
		 					Initialisation_I2C_1();
			                	return (-1);
						}
		        }
        /* Clear ADDR flag by reading SR2 register */
        temp = I2C1->SR2;
        /* Write the first data in DR register (EV8_1) */
        I2C1->DR = donnees[0];
        /* Increment */
        p++;
        /* Decrement the number of bytes to be written */
        nombre--;
	        /* While there is data to be written */
	        while(nombre--)
		        {
		            /* Poll on BTF to receive data because in polling mode we can not guarantee the
		              EV8 software sequence is managed before the current byte transfer completes */
		            while ((I2C1->SR1 & 0x00004) != 0x000004);
			            /* Send the current byte */
			            I2C1->DR = donnees[p];
			            /* Point to the next byte to be written */
			            p++;
		        }
	        /* EV8_2: Wait until BTF is set before programming the STOP */
	        while ((I2C1->SR1 & 0x00004) != 0x000004);
	        /* Send STOP condition */
	    I2C1->CR1 |= 0x0200;
	        /* Make sure that the STOP bit is cleared by Hardware */
	        while ((I2C1->CR1&0x200) == 0x200);

	    	return 1;
	}



/*Ecriture d'un octet grce au module  I2C 1  du STM32F100RB

Paramtres d'entre :

adresse - Adresse d'criture, sur le bus  I2C 1 , du composant que l'on souhaite crire,
donnees - Donne  crire.

Valeur de retour :

1 si l'criture s'est effectue correctement, -1 s'il y a eu une erreur lors de l'criture.

*/
int Ecrire(unsigned char adresse, unsigned char donnee)
	{
	 	unsigned char tampon[1];
			tampon[0] = donnee;
		return (EcrirePlusieursOctets(adresse, 1, tampon));
	}



/*Ecriture d'un octet, dans un registre d'un composant, grce au module  I2C 1  du STM32F100RB

Paramtres d'entre :

adresse - Adresse d'criture, sur le bus  I2C 1 , du composant que l'on souhaite crire,
commande - Numro du registre dans lequel on souhaite crire,
donnees - Donne  crire.

Valeur de retour :

1 si l'criture s'est effectue correctement, -1 s'il y a eu une erreur lors de l'criture.

*/
int Ecrire16Court(unsigned char adresse, unsigned char commande, unsigned char donnee) 
	{
	 	unsigned char tampon[2];
			tampon[0] = commande;
			tampon[1] = donnee;
		return (EcrirePlusieursOctets(adresse, 2, tampon));
	}



/*Ecriture de deux octets, dans un registre d'un composant, grce au module  I2C 1  du STM32F100RB

Paramtres d'entre :

adresse - Adresse d'criture, sur le bus  I2C 1 , du composant que l'on souhaite crire,
commande - Numro du registre dans lequel on souhaite crire,
donnees1 - Premier octet  crire, l'octet de poids fort,
donnees2 - Deuxime octet  crire, l'octet de poids faible.

Valeur de retour :

1 si l'criture s'est effectue correctement, -1 s'il y a eu une erreur lors de l'criture.

*/
int Ecrire16Nouvelle(unsigned char adresse, unsigned char commande, unsigned char donnee1, unsigned char donnee2)
	{
	 	unsigned char tampon[3];
			tampon[0] = commande;
			tampon[1] = donnee1;
			tampon[2] = donnee2;
		return (EcrirePlusieursOctets(adresse, 3, tampon));
	}



/*Remettre les donnes  l'endroit, avant de les envoyer aux broches  DB0    DB7  de l'afficheur alphanumrique

Paramtre d'entre :

paquet - Donne  retourner.

Valeur de retour :

Donne fournie en entre, retourne.

*/
unsigned char Retourner(unsigned char paquet)
	{
		int k;
		unsigned char collecteur[8];
		unsigned char envers;
			envers = 0;
				for(k = 0; k < 8; k++)
					{
						collecteur[k] = ((paquet >> k) & 0x01);
					}
				for(k = 0; k < 8; k++)
					{
						envers |= (collecteur[7 - k] << k);
					}
		return envers;
	}



/*Envoyer une commande  l'afficheur alphanumrique, grce au module  I2C 1  du STM32F100RB 

Paramtre d'entre :

commande - Commande  envoyer.

Valeur de retour :

Aucune.

*/
void EnvoiCommande(unsigned char commande)
	{
		commande = Retourner(commande);
			Ecrire16Nouvelle(AdresseCommande, 0x12, 0x00, ((EtatDesLED << 2 ) | 0x00));	/*PORTC = ((PORTC & 0xF8) | (0x00));*/	/*RS = 0, R/W = 0, E = 0*/
			Ecrire16Nouvelle(AdresseCommande, 0x12, commande, ((EtatDesLED << 2 ) & 0xF8));	/*PORTD = commande;*/	/*R/W = 0*/
			Ecrire16Nouvelle(AdresseCommande, 0x12, commande, ((EtatDesLED << 2 ) | 0x04));	/*PORTC = ((PORTC & 0xF8) | (0x04));*/ /*RS = 0, R/W = 0, E = 1*/
			Delai(300);
			Ecrire16Nouvelle(AdresseCommande, 0x12, commande, ((EtatDesLED << 2 ) & 0xF8));	/*PORTC = ((PORTC & 0xF8) | (0x00));*/	/*RS = 0, R/W = 0, E = 0*/
	}



/*Placer le curseur de l'afficheur alphanumrique  un endroi spcifi

Paramtre d'entre :

adresse_du_curseur - Adresse, sur l'afficheur alphanumrique, o placer le curseur.

Valeur de retour :

Aucune.

*/
void PlacerCurseur(unsigned char adresse_du_curseur)
	{
		EnvoiCommande(0x80 | adresse_du_curseur);
			AdresseCurseurActuelle = adresse_du_curseur;
	}



/*Envoyer une donne  l'afficheur alphanumrique, grce au module  I2C 1  du STM32F100RB 

Paramtre d'entre :

donnee - Donne  envoyer.

Valeur de retour :

Aucune.

*/
void EnvoiDonnee(unsigned char donnee)
	{
		donnee = Retourner(donnee);
		Ecrire16Nouvelle(AdresseCommande, 0x12, 0x00, ((EtatDesLED << 2 ) | 0x01));	/*PORTC = ((PORTC & 0xF8) | (0x01));*/	/*RS = 1*/
		Ecrire16Nouvelle(AdresseCommande, 0x12, donnee, ((EtatDesLED << 2 ) | 0x01));	/*PORTD = donnee;*/	/*RS = 1*/
		Ecrire16Nouvelle(AdresseCommande, 0x12, donnee, ((EtatDesLED << 2 ) | 0x05));	/*PORTC = ((PORTC & 0xF8) | (0x05));*/	/*RS = 1, E = 1*/
		Delai(3);
		Ecrire16Nouvelle(AdresseCommande, 0x12, donnee, ((EtatDesLED << 2 ) | 0x01));	/*PORTC = ((PORTC & 0xF8) | (0x01));*/	/*RS = 1*/
	}



/*Initialiser l'afficheur alphanumrique

Paramtre d'entre :

Aucun.

Valeur de retour :

Aucune.

*/
void InitialisationAfficheur(void)
	{
		int k;
		unsigned char commandes_pour_initialisation[5] = {0x01, 0x38, 0x0C, 0x06, 0x02};
			/*PORTC = 0x00;*/
			/*PORTD = 0x00;*/
				for(k = 0; k < 5; k++)
					{
						EnvoiCommande(commandes_pour_initialisation[k]);
					}
	}



/*Mettre en veille l'afficheur alphanumrique

Paramtre d'entre :

Aucun.

Valeur de retour :

Aucune.

*/
void MiseVeilleAfficheur(void)
	{
		int k;
		unsigned char commandes_pour_veille[3] = {0x01, 0x02, 0x08};
			/*PORTC = 0x00;*/
			/*PORTD = 0x00;*/
				for(k = 0; k < 3; k++)
					{
						EnvoiCommande(commandes_pour_veille[k]);
					}
	}



/*Obtenir l'adresse du curseur, sur l'afficheur alphanumrique, grce au module  I2C 1  du STM32F100RB 

Paramtre d'entre :

Aucun.

Valeur de retour :

Adresse du curseur, sur l'afficheur alphanumrique.

*/
unsigned char ObtenirAdresseActuelle(void)
	{
		unsigned char valeur_adresse_obtenue, c;
			c = 0;
			Ecrire16Nouvelle(AdresseCommande, 0x00, 0xFF, 0x00); 	/*TRISD = 0xFF;*/
			Ecrire16Nouvelle(AdresseCommande, 0x12, 0x00, ((EtatDesLED << 2 ) | 0x06));	/*PORTC = ((PORTC & 0xF8) | (0x06));*/	/*RS = 0, R/W = 1, E = 1*/
			Delai(3);
			Lire16Nouvelle(AdresseCommande, 0x12, (AdresseCommande | 0x01), &valeur_adresse_obtenue, &c);	/*valeur_adresse_obtenue = PORTD;*/	/*RS = 0, R/W = 1, E = 1*/
			Ecrire16Nouvelle(AdresseCommande, 0x00, 0x00, 0x00);	/*TRISD = 0x00;*/
			Ecrire16Nouvelle(AdresseCommande, 0x12, 0x00, ((EtatDesLED << 2 ) | 0x02));	/*PORTC = ((PORTC & 0xF8) | (0x02));*/	/*RS = 0, R/W = 1, E = 0*/
			valeur_adresse_obtenue = Retourner(valeur_adresse_obtenue);
			AdresseCurseurActuelle = valeur_adresse_obtenue;
		return valeur_adresse_obtenue;
	}



/*Afficher un caractre, sur l'afficheur alphanumrique

Paramtre d'entre :

c - Code ASCII du caractre  afficher.

Valeur de retour :

Aucune.

*/
void AfficheCaractere(unsigned char c)
	{
		EnvoiDonnee(c);
			if(ObtenirAdresseActuelle() == 0x08)
				{
					PlacerCurseur(0x28);
				}
	}



/*Afficher un texte, sur l'afficheur alphanumrique

Paramtre d'entre :

* texte - Chane de caractres, contenant les codes ASCII des caractres  afficher.

Valeur de retour :

Aucune.

*/
void AfficheTexte(unsigned char * texte)
	{
		int i = 0;
		while (texte[i] != '\0')
			{
				AfficheCaractere(texte[i]);
					i++;
			}
	}



/*Envoyer une ligne d'un caractre spcial, dfini par l'utilisateur,  l'afficheur alphanumrique, grce au module  I2C 1  du STM32F100RB 

Paramtre d'entre :

uoct_special - Correspond au points de l'afficheur  solliciter, pour former la ligne du caractre spcial dfini par l'utilisateur.

Valeur de retour :

Aucune.

*/
void CommandeSpeciale(unsigned char uoct_special)
	{
		Ecrire16Nouvelle(AdresseCommande, 0x12, 0x00, ((EtatDesLED << 2 ) | 0x01));	/*RS = 1, R/W = 0, E = 0*/
		Ecrire16Nouvelle(AdresseCommande, 0x12, Retourner(uoct_special), ((EtatDesLED << 2 ) | 0x01));	/*RS = 1, R/W = 0, E = 0*/
		Delai(3);
		Ecrire16Nouvelle(AdresseCommande, 0x12, Retourner(uoct_special), ((EtatDesLED << 2 ) | 0x05));	/*RS = 1, R/W = 0, E = 1*/
		Delai(3);
		Ecrire16Nouvelle(AdresseCommande, 0x12, Retourner(uoct_special), ((EtatDesLED << 2 ) | 0x01));	/*RS = 1, R/W = 0, E = 0*/
	}



/*Envoyer huit caractres spciaux, dfini par l'utilisateur,  l'afficheur alphanumrique 

Paramtre d'entre :

str_nouveaucaractere - Tableau contenant la dfinition des huit caractres spciaux, dfinis par l'utilisateur.

Valeur de retour :

Aucune.

*/
void ChargeCaracteres(unsigned char str_nouveaucaractere[])
	{
	    int i;
		EnvoiCommande(0x40);
			for(i = 0; i < 56; i++)
				{
					CommandeSpeciale(str_nouveaucaractere[i]);
				}
	    PlacerCurseur(0x00);
	}



/*Convertir un nombre dans une base, et afficher le rsultat de cette conversion, sur l'afficheur alphanumrique  

Paramtres d'entre :

valeur - Nombre  afficher.
base - Base de comptage du nombre  afficher, comprise entre 2 et 16.

Valeur de retour :

Aucune.

*/
void ConvertirEtAfficher(int valeur, unsigned char base)
	{
		unsigned char symboles[16] = {'0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'A', 'B', 'C', 'D', 'E', 'F'};
		int k = 0;
		static unsigned char tampon[8];
			if((base == 10) && (valeur == 625))
				{
					AfficheCaractere('0');
				}
			if((base == 10) && (valeur == 0))
				{
					AfficheTexte("000");
				}
			do
				{
					tampon[k]= symboles[valeur % base];
					valeur = valeur / base;
					k++;
				}
		while(valeur > 0);
		if((k == 1) && (base == 16))
			{
				AfficheCaractere('0');
			}
		do
			{
				k--;
				AfficheCaractere(tampon[k]);		
			}
		while(k > 0);
	}



/*Configurer un capteur de temprature TMP100 

Paramtre d'entre :

a - Adresse d'criture, sur le bus  I2C 1 , du capteur de temprature TMP100 que l'on souhaite configurer.

Valeur de retour :

1 si la configuration s'est effectue correctement, -1 s'il y a eu une erreur lors de la configuration.

*/
int Configuration_pour_capteur(unsigned char a)
	{
		if((Ecrire16Court(a, 0x01, 0x60)) == (-1))	/*Ecriture dans le  Configuration Register  :
												SD = 0 : Dsactivation du  Shutdown Mode ,
												TM = 0 : Non utilis pour le TMP100,
												POL = 0 : Non utilis pour le TMP100,
												F0 = 0, F1 = 0 : Non utilis pour le TMP100,
												R0 = 1, R1 = 1 : Choix de la rsolution maximale,
												pour la conversion de la temprature, soit sur 12 bits, par pas de 0.0625C,
												ce qui signifie que le temps de conversion est de 320 ms*/
			{
				return (-1);
			}
					return 1;
	}



/*Fonction principale 

Paramtre d'entre :

Aucun.

Valeur de retour :

Aucune.

*/
int main (void)
	{
		unsigned char E1 = 0;
		unsigned char E2 = 0;

		AdresseCurseurActuelle = 0;

    	Initialisation_I2C_1();	/*Initialisation du module  I2C 1  du STM32F100RB en tant que  Matre */
			
		Ecrire(AdresseExpanseur1, 0xFF);	/*Mise de toutes les broches du premier expanseur de port   1 */
		Ecrire(AdresseExpanseur2, 0xFF);	/*Mise de toutes les broches du deuxime expanseur de port   1 */

		Ecrire16Nouvelle(AdresseCommande, 0x00, 0x00, 0x00);	/*Configuration des 16 broches du circuit intgr MCP23017 en sorties*/
		Ecrire16Nouvelle(AdresseCommande, 0x12, 0x00, 0x00);	/*Mise de chacune des 16 broches du circuit intgr MCP23017   0 */

		EtatDesLED = 0x00;

		InitialisationAfficheur();

		EnvoiCommande(0x01);	/*Effacement de l'afficheur LCD*/
		Delai(1000);
		PlacerCurseur(0x00);

		ChargeCaracteres(speciaux);

		Configuration_pour_capteur(AdresseCapteur);

		Ecrire(AdresseExpanseur1, 0xAA);	/*Mise d'une broche sur deux du premier expanseur de port   1 */
		Ecrire(AdresseExpanseur2, 0xAA);	/*Mise d'une broche sur deux du deuxime expanseur de port   1 */
			 
			while(1)
				{
					Lire16Nouvelle(AdresseCapteur, 0x00, (AdresseCapteur | 0x01), &E1, &E2);	/*Lecture des deux registres de 8 bits
																								qui contiennent la valeur de
																								la temprature mesure*/

					Ecrire(AdresseExpanseur1, ~(1 << (E1 - 15)));	
					Ecrire(AdresseExpanseur2, ~(1 << (((E2 >> 4) & 0x0F) * 1) / 2));

					EnvoiCommande(0x01);	/*Effacement de l'afficheur LCD*/
					Delai(1000);
					PlacerCurseur(0x00);
					AfficheTexte("0x");	/*Dbut de l'affichage de la valeur hexadcimale correspondant  la temprature*/
					ConvertirEtAfficher(E1, 16);
					ConvertirEtAfficher(E2, 16);

					PlacerCurseur(0x07);	/*Dplacement du curseur de l'afficheur pour prparer l'affichage de la temprature convertie en degrs Celsius*/
					ConvertirEtAfficher(E1, 10);	/*Affichage du nombre avant la virgule*/
					AfficheCaractere(',');	/*Affichage de la virgule*/
					ConvertirEtAfficher((((E2 >> 4) & 0x0F) * 625), 10);	/*Affichage du nombre aprs la virgule, au 16e de degr Celsuis prs*/
					AfficheCaractere(0);	/*Affichage du caractre programm  l'adresse 0x00 dans la RAM de l'afficheur LCD, soit le symbole   */
					AfficheCaractere('C');
					Delai(10000);
				}
	}



/*Fonction qui permet l'initialisation du microcontrleur STM32F100RB

Paramtre d'entre :

Aucun.

Valeur de retour :

Aucune.

*/
void SystemInit (void)
	{
	
	}
